: $Id: poisgen.mod,v 1.8 1996/06/06 23:43:38 billl Exp $
: comments at end

INDEPENDENT {t FROM 0 TO 1 WITH 1 (ms)}

NEURON	{ 
  POINT_PROCESS poisgen
  RANGE lambda,pexp,snpt
  GLOBAL thresh     : this is defined but not used; it foils VECTORIZE which had foiled me
}

PARAMETER {
  lambda = 0.004    : 1/250, P(n,T) = exp(-lambda*T)*(lambda*T)^n/n!
  thresh = 0
}

ASSIGNED {
  pexp
  snpt
  dt
}

INCLUDE "presyn2.inc"

INITIAL {
  : for now assume negligible prob of 2 events in dt
  : ==> Poisson prob of 1 event in 1 time step in nsyn syns =
  pexp = exp(-nsyn*dt*lambda)*(nsyn*dt*lambda) 
}	

BREAKPOINT {
  SOLVE generate
}

PROCEDURE generate() {
  VERBATIM {
  if (drand48() < pexp) {
    snpt = floor(nsyn*drand48());
    newspike(snpt);
  }
  }
  ENDVERBATIM
}

: unable to get the drand here to recognize the same fseed used in rand
PROCEDURE fseed(seed) {
  VERBATIM
  srand48((unsigned)_lseed);
  ENDVERBATIM
}

COMMENT
Presynaptic spike generator
---------------------------
Generate random poisson events in a network of synapses.
pexp gives the probability of 1 activation occurring in nsyn synapses
during a period given by the Poisson parameter lambda such that 
prob of n events in period T for a single syn would be:
  P(n,T) = exp(-lambda*T)*(lambda*T)^n/n!
Note that dead time for individual syns is not accounted for.  Also if
nsyn gets too large, such that there is a large prob of 2 spikes,
should spin off a second poisgen that takes over half of the syns.

ENDCOMMENT

